#include <iostream>
#include <string>
#include "cudafuncs.h"
#include <windows.h>

int gDone;  ///< Global variable used to wait for thread to finish

/**
 * Function that is executed in the background thread.  It calls
 * a couple of CUDA routines.
 */
DWORD WINAPI WorkingFunction(LPVOID pv)
{
    RunCudaTest();
    ShutdownCuda();
    gDone = 1;
    return 0;
}

/**
 * Function that invokes 'WorkingFunction' on a background thread
 */
void RunInBkgThread(HANDLE& hThr)
{
    DWORD lThreadID;
    hThr = CreateThread(NULL, 0, WorkingFunction, NULL, 
        THREAD_PRIORITY_NORMAL, &lThreadID);
    return;
}// RunInBkgThread

/**
 * Main program
 */
int main(int argc, char* argv[])
{
    HANDLE hThr;

    // Go through several iterations and watch the number
    // of Semaphore and Mutant handles grow...
    for (int i = 0; i < 25; ++i)
    {
        gDone = 0;
        // Run, then loop till it finishes
        RunInBkgThread(hThr);
        while (0 == gDone)
        {
            Sleep(20);
        }

        // Cleanup resources
        CloseHandle(hThr); 
        int p = 4;
    }// i loop over trials

    return 0;
}// main

